VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SimpleDragAndDrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-------------------------------------------------------------------------
' SimpleDragAndDrop.cls
' Permite Tomar y Soltar un objetos graficos
' como botones y pictures box
'
' General Info:
'
' Author: Edric Navarro
' Email: NavarroHidalgo@hotmail.com
' Date: 16/06/05, Venezuela-Zulia-Maracaibo
'
' E-Mail me for question and code resource ...
'-------------------------------------------------------------------------

Option Explicit

'>>>>>>>>>>>>>>>>>>>>>>>>
Public objObject As Object
Attribute objObject.VB_VarHelpID = -1
Dim objContainer As Object
Attribute objContainer.VB_VarHelpID = -1

Public Xpos, Ypos, DrgXpos, DrgYpos, Ymax, Ymin, Xmax, Xmin
Public mbolDragObj As Boolean

Enum udtLimitMode
   NoLimits ' 0  auto enumeration
   LimitToStageArea ' 1  auto enumeration
   LimitToSpecificArea ' 2  auto enumeration
End Enum

Public LimitMode As udtLimitMode
'>>>>>>>>>>>>>>>>>>>>>>>>

Private Sub Class_Initialize()
    LimitMode = NoLimits
    mbolDragObj = False
    Xmax = Null
    Xmin = Null
    Ymax = Null
    Ymin = Null
End Sub

Public Sub DragObj(bolDragObj As Boolean, Optional X As Single, Optional Y As Single)
    Set objContainer = objObject.Container
    mbolDragObj = bolDragObj
    If mbolDragObj = True Then
        DrgXpos = X
        DrgYpos = Y
    End If
End Sub

Public Sub MoveObj(X As Single, Y As Single)
    If mbolDragObj = True Then
        Xpos = objObject.Left + X - DrgXpos
        Ypos = objObject.Top + Y - DrgYpos
        Select Case LimitMode
            Case 0 ' No limits
                ' Do Nothing
            Case 1 ' LimitToStageArea
                If (Xpos + objObject.Width) >= objContainer.Width Then Xpos = objContainer.Width - objObject.Width
                If Xpos < 0 Then Xpos = 0
                If (Ypos + objObject.Height) >= objContainer.Height Then Ypos = objContainer.Height - objObject.Height
                If Ypos < 0 Then Ypos = 0
            Case 2 ' LimitToSpecificArea
                If Xmax < Xmin Or Ymax < Ymin Then Error (5) ' El argumento o la llamada al procedimiento no son vlidos (Error 5)
                If (Xpos + objObject.Width) >= Xmax Then Xpos = Xmax - objObject.Width
                If Xpos <= Xmin Then Xpos = Xmin
                If (Ypos + objObject.Height) >= Ymax Then Ypos = Ymax - objObject.Height
                If Ypos <= Ymin Then Ypos = Ymin
        End Select
        
        objObject.Left = Xpos
        objObject.Top = Ypos
    End If
End Sub

